module("luci.controller.mwan3",package.seeall)
sys=require"luci.sys"
ut=require"luci.util"
ip="ip -4 "
function index()
if not nixio.fs.access("/etc/config/mwan3")then
return
end
entry({"admin","status","mwan"},
alias("admin","status","mwan","overview"),
_("Load Balancing"),600).acl_depends={"luci-app-mwan3"}
entry({"admin","status","mwan","overview"},
template("mwan/status_interface"))
entry({"admin","status","mwan","detail"},
template("mwan/status_detail"))
entry({"admin","status","mwan","diagnostics"},
template("mwan/status_diagnostics"))
entry({"admin","status","mwan","troubleshooting"},
template("mwan/status_troubleshooting"))
entry({"admin","status","mwan","interface_status"},
call("mwan_Status"))
entry({"admin","status","mwan","detailed_status"},
call("detailedStatus"))
entry({"admin","status","mwan","diagnostics_display"},
call("diagnosticsData"),nil).leaf=true
entry({"admin","status","mwan","troubleshooting_display"},
call("troubleshootingData"))
entry({"admin","network","mwan"},
alias("admin","network","mwan","interface"),
_("Load Balancing"),600).acl_depends={"luci-app-mwan3"}
entry({"admin","network","mwan","globals"},
cbi("mwan/globalsconfig"),
_("Globals"),5).leaf=true
entry({"admin","network","mwan","interface"},
arcombine(cbi("mwan/interface"),cbi("mwan/interfaceconfig")),
_("Interfaces"),10).leaf=true
entry({"admin","network","mwan","member"},
arcombine(cbi("mwan/member"),cbi("mwan/memberconfig")),
_("Members"),20).leaf=true
entry({"admin","network","mwan","policy"},
arcombine(cbi("mwan/policy"),cbi("mwan/policyconfig")),
_("Policies"),30).leaf=true
entry({"admin","network","mwan","rule"},
arcombine(cbi("mwan/rule"),cbi("mwan/ruleconfig")),
_("Rules"),40).leaf=true
entry({"admin","network","mwan","notify"},
form("mwan/notify"),
_("Notification"),50).leaf=true
end
function mwan_Status()
local e=ut.ubus("mwan3","status",{})
luci.http.prepare_content("application/json")
if e~=nil then
luci.http.write_json(e)
else
luci.http.write_json({})
end
end
function detailedStatus()
local e=ut.trim(sys.exec("/usr/sbin/mwan3 status"))
luci.http.prepare_content("text/plain")
if e~=""then
luci.http.write(e)
else
luci.http.write("Unable to get status information")
end
end
function diagnosticsData(e,a)
function getInterfaceNumber(o)
local e=0
local t
local a=require"luci.model.uci".cursor()
a:foreach("mwan3","interface",
function(a)
e=e+1
if a[".name"]==o then
t=e
end
end
)
return t
end
function diag_command(a,o,e)
if e and e:match("^[a-zA-Z0-9%-%.:_]+$")then
local t=io.popen(a%{ut.shellquote(o),ut.shellquote(e)})
if t then
luci.http.write("Command:\n")
luci.http.write(a%{ut.shellquote(o),
ut.shellquote(e)}.."\n\n")
luci.http.write("Result:\n")
while true do
local e=t:read("*l")
if not e then break end
luci.http.write(e)
luci.http.write("\n")
end
t:close()
end
return
end
end
function get_gateway(a)
local t=nil
local e=nil
e=require("luci.util").ubus("network.interface.%s_4"%a,"status",{})
if not e then
e=require("luci.util").ubus("network.interface.%s"%a,"status",{})
end
if e and e.route then
local a,a
for a,o in ipairs(e.route)do
if e.route[a].target=="0.0.0.0"then
t=e.route[a].nexthop
end
end
end
return t
end
local t={}
local t=""
local t=getInterfaceNumber(e)
local i=require"luci.model.uci".cursor(nil,"/var/state")
local o=require"luci.model.network".init()
local t=require"luci.i18n"
local o=o:get_network(e)
local o=o and o:get_interface()
o=o:name()
luci.http.prepare_content("text/plain")
if o then
if a=="ping_gateway"then
local a=get_gateway(e)
if a~=nil then
diag_command("ping -I %s -c 5 -W 1 %s 2>&1",o,a)
else
luci.http.prepare_content("text/plain")
luci.http.write(t.translatef("No gateway for interface %s found.",e))
end
elseif a=="ping_trackips"then
local a=i:get("mwan3",e,"track_ip")
if#a>0 then
for e in pairs(a)do
diag_command("ping -I %s -c 5 -W 1 %s 2>&1",o,a[e])
end
else
luci.http.write(t.translatef("No tracking Hosts for interface %s defined.",e))
end
elseif a=="check_rules"then
local a=getInterfaceNumber(e)
local i=1000+a
local o=2000+a
local a=sys.exec(string.format("ip rule | grep %d",i))
local o=sys.exec(string.format("ip rule | grep %d",o))
if a~=""and o~=""then
luci.http.write(t.translatef("All required IP rules for interface %s found",e))
luci.http.write("\n")
luci.http.write(o)
luci.http.write(a)
elseif a==""and o~=""then
luci.http.write(t.translatef("Only one IP rules for interface %s found",e))
luci.http.write("\n")
luci.http.write(o)
elseif a~=""and o==""then
luci.http.write(t.translatef("Only one IP rules for interface %s found",e))
luci.http.write("\n")
luci.http.write(a)
else
luci.http.write(t.translatef("Missing both IP rules for interface %s",e))
end
elseif a=="check_routes"then
local a=getInterfaceNumber(e)
local o=sys.exec(string.format("ip route list table %s",a))
if o~=""then
luci.http.write(t.translatef("Routing table %s for interface %s found",a,e))
luci.http.write("\n")
luci.http.write(o)
else
luci.http.write(t.translatef("Routing table %s for interface %s not found",a,e))
end
elseif a=="hotplug_ifup"then
os.execute(string.format("/usr/sbin/mwan3 ifup %s",ut.shellquote(e)))
luci.http.write(string.format("Hotplug ifup sent to interface %s",e))
elseif a=="hotplug_ifdown"then
os.execute(string.format("/usr/sbin/mwan3 ifdown %s",ut.shellquote(e)))
luci.http.write(string.format("Hotplug ifdown sent to interface %s",e))
else
luci.http.write("Unknown task")
end
else
luci.http.write(string.format("Unable to perform diagnostic tests on %s.",e))
luci.http.write("\n")
luci.http.write("There is no physical or virtual device associated with this interface.")
end
end
function troubleshootingData()
local t=require"luci.version"
local e="-------------------------------------------------"
luci.http.prepare_content("text/plain")
luci.http.write("\n")
luci.http.write("\n")
luci.http.write("Software-Version")
luci.http.write("\n")
luci.http.write(e)
luci.http.write("\n")
if t.distversion then
luci.http.write(string.format("OpenWrt - %s",t.distversion))
luci.http.write("\n")
else
luci.http.write("OpenWrt - unknown")
luci.http.write("\n")
end
if t.luciversion then
luci.http.write(string.format("LuCI - %s",t.luciversion))
luci.http.write("\n")
else
luci.http.write("LuCI - unknown")
luci.http.write("\n")
end
luci.http.write("\n")
luci.http.write("\n")
local t=ut.trim(sys.exec("ip a show"))
luci.http.write("Output of \"ip a show\"")
luci.http.write("\n")
luci.http.write(e)
luci.http.write("\n")
if t~=""then
luci.http.write(t)
luci.http.write("\n")
else
luci.http.write("No data found")
luci.http.write("\n")
end
luci.http.write("\n")
luci.http.write("\n")
local t=ut.trim(sys.exec("ip route show"))
luci.http.write("Output of \"ip route show\"")
luci.http.write("\n")
luci.http.write(e)
luci.http.write("\n")
if t~=""then
luci.http.write(t)
luci.http.write("\n")
else
luci.http.write("No data found")
luci.http.write("\n")
end
luci.http.write("\n")
luci.http.write("\n")
local t=ut.trim(sys.exec("ip rule show"))
luci.http.write("Output of \"ip rule show\"")
luci.http.write("\n")
luci.http.write(e)
luci.http.write("\n")
if t~=""then
luci.http.write(t)
luci.http.write("\n")
else
luci.http.write("No data found")
luci.http.write("\n")
end
luci.http.write("\n")
luci.http.write("\n")
luci.http.write("Output of \"ip route list table 1-250\"")
luci.http.write("\n")
luci.http.write(e)
luci.http.write("\n")
for e=1,250 do
local t=ut.trim(sys.exec(string.format("ip route list table %d",e)))
if t~=""then
luci.http.write(string.format("Table %s: ",e))
luci.http.write(t)
luci.http.write("\n")
end
end
luci.http.write("\n")
luci.http.write("\n")
local t=ut.trim(sys.exec("iptables -L -t mangle -v -n"))
luci.http.write("Output of \"iptables -L -t mangle -v -n\"")
luci.http.write("\n")
luci.http.write(e)
luci.http.write("\n")
if t~=""then
luci.http.write(t)
luci.http.write("\n")
else
luci.http.write("No data found")
luci.http.write("\n")
end
end
