local m=require"luci.dispatcher"
local h=require"uci"
local i,t,s,d,u,c
local l,n,r
function interfaceWarnings(a,t,o)
local e=""
if t<=o then
e=string.format("<strong>%s</strong><br />",
translatef("There are currently %d of %d supported interfaces configured",t,o)
)
else
e=string.format("<strong>%s</strong><br />",
translatef("WARNING: %d interfaces are configured exceeding the maximum of %d!",t,o)
)
end
for t,o in pairs(a)do
if a[t]["network"]==false then
e=e..string.format("<strong>%s</strong><br />",
translatef("WARNING: Interface %s are not found in /etc/config/network",t)
)
end
if a[t]["default_route"]==false then
e=e..string.format("<strong>%s</strong><br />",
translatef("WARNING: Interface %s has no default route in the main routing table",t)
)
end
if a[t]["reliability"]==false then
e=e..string.format("<strong>%s</strong><br />",
translatef("WARNING: Interface %s has a higher reliability "..
"requirement than tracking hosts (%d)",t,a[t]["tracking"])
)
end
if a[t]["duplicate_metric"]==true then
e=e..string.format("<strong>%s</strong><br />",
translatef("WARNING: Interface %s has a duplicate metric %s configured",t,a[t]["metric"])
)
end
end
return e
end
function configCheck()
local t={}
local n=0
local o={}
h.cursor():foreach("mwan3","interface",
function(e)
local a=h.cursor(nil,"/var/state")
local e=e[".name"]
t[e]={}
n=n+1
local i=a:get("network",e)
t[e]["network"]=false
if i~=nil then
t[e]["network"]=true
local i=a:get("network",e,"ifname")
if i~=nil then
t[e]["device"]=i
end
local a=a:get("network",e,"metric")
if a~=nil then
t[e]["metric"]=a
t[e]["duplicate_metric"]=false
for i,o in ipairs(o)do
if o==a then
t[e]["duplicate_metric"]=true
end
end
table.insert(o,a)
end
local a=require("luci.util").ubus("network.interface.%s"%e,"status",{})
t[e]["default_route"]=false
if a and a.route then
local o,o
for o,i in ipairs(a.route)do
if a.route[o].target=="0.0.0.0"then
t[e]["default_route"]=true
end
end
end
end
local o=a:get("mwan3",e,"track_ip")
t[e]["tracking"]=0
if o and#o>0 then
t[e]["tracking"]=#o
t[e]["reliability"]=false
local a=tonumber(a:get("mwan3",e,"reliability")or"1")
if a and a<=#o then
t[e]["reliability"]=true
end
end
end
)
function bit(e)
return 2^(e-1)
end
function hasbit(t,e)
return t%(e+e)>=e
end
function setbit(e,t)
return hasbit(e,t)and e or e+t
end
local e=require("uci").cursor(nil,"/var/state")
local e=e:get("mwan3","globals","mmx_mask")or"0x3F00"
local o=tonumber(e,16)
local a=0
local e=0
for t=1,16 do
if hasbit(o,bit(t))then
a=a+1
e=setbit(e,bit(a))
end
end
e=e-3
return t,n,e
end
i=Map("mwan3",translate("MWAN - Interfaces"),
interfaceWarnings(configCheck()))
t=i:section(TypedSection,"interface",nil,
translate("mwan3 requires that all interfaces have a unique metric configured in /etc/config/network<br />"..
"Names must match the interface name found in /etc/config/network<br />"..
"Names may contain characters A-Z, a-z, 0-9, _ and no spaces<br />"..
"Interfaces may not share the same name as configured members, policies or rules"))
t.addremove=true
t.dynamic=false
t.sectionhead=translate("Interface")
t.sortable=false
t.template="cbi/tblsection"
t.extedit=m.build_url("admin","network","mwan","interface","%s")
function t.create(t,e)
TypedSection.create(t,e)
i.uci:save("mwan3")
luci.http.redirect(m.build_url("admin","network","mwan","interface",e))
end
s=t:option(DummyValue,"enabled",translate("Enabled"))
s.rawhtml=true
function s.cfgvalue(e,t)
if e.map:get(t,"enabled")=="1"then
return translate("Yes")
else
return translate("No")
end
end
d=t:option(DummyValue,"track_method",translate("Tracking method"))
d.rawhtml=true
function d.cfgvalue(e,t)
local a=e.map:get(t,"track_ip")
if a then
return e.map:get(t,"track_method")or"ping"
else
return"&#8212;"
end
end
u=t:option(DummyValue,"reliability",translate("Tracking reliability"))
u.rawhtml=true
function u.cfgvalue(e,t)
local a=e.map:get(t,"track_ip")
if a then
return e.map:get(t,"reliability")or"1"
else
return"&#8212;"
end
end
c=t:option(DummyValue,"interval",translate("Ping interval"))
c.rawhtml=true
function c.cfgvalue(e,t)
local a=e.map:get(t,"track_ip")
if a then
local e=e.map:get(t,"interval")
if e then
return e.."s"
else
return"5s"
end
else
return"&#8212;"
end
end
l=t:option(DummyValue,"down",translate("Interface down"))
l.rawhtml=true
function l.cfgvalue(t,e)
local a=t.map:get(e,"track_ip")
if a then
return t.map:get(e,"down")or"3"
else
return"&#8212;"
end
end
n=t:option(DummyValue,"up",translate("Interface up"))
n.rawhtml=true
function n.cfgvalue(e,t)
local a=e.map:get(t,"track_ip")
if a then
return e.map:get(t,"up")or"3"
else
return"&#8212;"
end
end
r=t:option(DummyValue,"metric",translate("Metric"))
r.rawhtml=true
function r.cfgvalue(t,e)
local t=h.cursor(nil,"/var/state")
local e=t:get("network",e,"metric")
if e then
return e
else
return"&#8212;"
end
end
return i
