local _=require"luci.dispatcher"
local v,e,z,p,b,x
local u,j,f,i,d
local k,r,c,l
local m,n,t,o
local g,a,s,h,w,q
local y
arg[1]=arg[1]or""
v=Map("mwan3",translatef("MWAN Interface Configuration - %s",arg[1]))
v.redirect=_.build_url("admin","network","mwan","interface")
e=v:section(NamedSection,arg[1],"interface","")
e.addremove=false
e.dynamic=false
z=e:option(Flag,"enabled",translate("Enabled"))
z.default=false
p=e:option(ListValue,"initial_state",translate("Initial state"),
translate("Expect interface state on up event"))
p.default="online"
p:value("online",translate("Online"))
p:value("offline",translate("Offline"))
b=e:option(ListValue,"family",translate("Internet Protocol"))
b.default="ipv4"
b:value("ipv4",translate("IPv4"))
b:value("ipv6",translate("IPv6"))
x=e:option(DynamicList,"track_ip",translate("Tracking hostname or IP address"),
translate("This hostname or IP address will be pinged to determine if the link is up or down. Leave blank to assume interface is always online"))
x.datatype="host"
u=e:option(ListValue,"track_method",translate("Tracking method"))
u.default="ping"
u:value("ping")
if os.execute("command -v nping 1>/dev/null")==0 then
u:value("nping-tcp")
u:value("nping-udp")
u:value("nping-icmp")
u:value("nping-arp")
end
if os.execute("command -v arping 1>/dev/null")==0 then
u:value("arping")
end
if os.execute("command -v httping 1>/dev/null")==0 then
u:value("httping")
end
y=e:option(Flag,"httping_ssl",translate("Enable ssl tracking"),
translate("Enables https tracking on ssl port 443"))
y:depends("track_method","httping")
y.rmempty=false
y.default=y.enabled
j=e:option(Value,"reliability",translate("Tracking reliability"),
translate("Acceptable values: 1-100. This many Tracking IP addresses must respond for the link to be deemed up"))
j.datatype="range(1, 100)"
j.default="1"
f=e:option(ListValue,"count",translate("Ping count"))
f.default="1"
f:value("1")
f:value("2")
f:value("3")
f:value("4")
f:value("5")
i=e:option(Value,"size",translate("Ping size"))
i.default="56"
i:depends("track_method","ping")
i:value("8")
i:value("24")
i:value("56")
i:value("120")
i:value("248")
i:value("504")
i:value("1016")
i:value("1472")
i:value("2040")
i.datatype="range(1, 65507)"
d=e:option(Value,"max_ttl",translate("Max TTL"))
d.default="60"
d:depends("track_method","ping")
d:value("10")
d:value("20")
d:value("30")
d:value("40")
d:value("50")
d:value("60")
d:value("70")
d.datatype="range(1, 255)"
k=e:option(Flag,"check_quality",translate("Check link quality"))
k:depends("track_method","ping")
k.default=false
r=e:option(Value,"failure_latency",translate("Failure latency [ms]"))
r:depends("check_quality",1)
r.default="1000"
r:value("25")
r:value("50")
r:value("75")
r:value("100")
r:value("150")
r:value("200")
r:value("250")
r:value("300")
c=e:option(Value,"failure_loss",translate("Failure packet loss [%]"))
c:depends("check_quality",1)
c.default="40"
c:value("2")
c:value("5")
c:value("10")
c:value("20")
c:value("25")
l=e:option(Value,"recovery_latency",translate("Recovery latency [ms]"))
l:depends("check_quality",1)
l.default="500"
l:value("25")
l:value("50")
l:value("75")
l:value("100")
l:value("150")
l:value("200")
l:value("250")
l:value("300")
m=e:option(Value,"recovery_loss",translate("Recovery packet loss [%]"))
m:depends("check_quality",1)
m.default="10"
m:value("2")
m:value("5")
m:value("10")
m:value("20")
m:value("25")
n=e:option(ListValue,"timeout",translate("Ping timeout"))
n.default="4"
n:value("1",translatef("%d second",1))
n:value("2",translatef("%d seconds",2))
n:value("3",translatef("%d seconds",3))
n:value("4",translatef("%d seconds",4))
n:value("5",translatef("%d seconds",5))
n:value("6",translatef("%d seconds",6))
n:value("7",translatef("%d seconds",7))
n:value("8",translatef("%d seconds",8))
n:value("9",translatef("%d seconds",9))
n:value("10",translatef("%d seconds",10))
t=e:option(ListValue,"interval",translate("Ping interval"))
t.default="10"
t:value("1",translatef("%d second",1))
t:value("3",translatef("%d seconds",3))
t:value("5",translatef("%d seconds",5))
t:value("10",translatef("%d seconds",10))
t:value("20",translatef("%d seconds",20))
t:value("30",translatef("%d seconds",30))
t:value("60",translatef("%d minute",1))
t:value("300",translatef("%d minutes",5))
t:value("600",translatef("%d minutes",10))
t:value("900",translatef("%d minutes",15))
t:value("1800",translatef("%d minutes",30))
t:value("3600",translatef("%d hour",1))
o=e:option(Value,"failure_interval",translate("Failure interval"),
translate("Ping interval during failure detection"))
o.default="5"
o:value("1",translatef("%d second",1))
o:value("3",translatef("%d seconds",3))
o:value("5",translatef("%d seconds",5))
o:value("10",translatef("%d seconds",10))
o:value("20",translatef("%d seconds",20))
o:value("30",translatef("%d seconds",30))
o:value("60",translatef("%d minute",1))
o:value("300",translatef("%d minutes",5))
o:value("600",translatef("%d minutes",10))
o:value("900",translatef("%d minutes",15))
o:value("1800",translatef("%d minutes",30))
o:value("3600",translatef("%d hour",1))
g=e:option(Flag,"keep_failure_interval",translate("Keep failure interval"),
translate("Keep ping failure interval during failure state"))
g.default=g.disabled
a=e:option(Value,"recovery_interval",translate("Recovery interval"),
translate("Ping interval during failure recovering"))
a.default="5"
a:value("1",translatef("%d second",1))
a:value("3",translatef("%d seconds",3))
a:value("5",translatef("%d seconds",5))
a:value("10",translatef("%d seconds",10))
a:value("20",translatef("%d seconds",20))
a:value("30",translatef("%d seconds",30))
a:value("60",translatef("%d minute",1))
a:value("300",translatef("%d minutes",5))
a:value("600",translatef("%d minutes",10))
a:value("900",translatef("%d minutes",15))
a:value("1800",translatef("%d minutes",30))
a:value("3600",translatef("%d hour",1))
s=e:option(ListValue,"down",translate("Interface down"),
translate("Interface will be deemed down after this many failed ping tests"))
s.default="5"
s:value("1")
s:value("2")
s:value("3")
s:value("4")
s:value("5")
s:value("6")
s:value("7")
s:value("8")
s:value("9")
s:value("10")
h=e:option(ListValue,"up",translate("Interface up"),
translate("Downed interface will be deemed up after this many successful ping tests"))
h.default="5"
h:value("1")
h:value("2")
h:value("3")
h:value("4")
h:value("5")
h:value("6")
h:value("7")
h:value("8")
h:value("9")
h:value("10")
w=e:option(StaticList,"flush_conntrack",translate("Flush conntrack table"),
translate("Flush global firewall conntrack table on interface events"))
w:value("ifup",translate("ifup (netifd)"))
w:value("ifdown",translate("ifdown (netifd)"))
w:value("connected",translate("connected (mwan3)"))
w:value("disconnected",translate("disconnected (mwan3)"))
q=e:option(DummyValue,"metric",translate("Metric"),
translate("This displays the metric assigned to this interface in /etc/config/network"))
q.rawhtml=true
function q.cfgvalue(e,e)
local e=require"luci.model.uci".cursor(nil,"/var/state")
local e=e:get("network",arg[1],"metric")
if e then
return e
else
return"&#8212;"
end
end
return v
